//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_combat.cpp
//
/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

edict_t *BotFindEnemy( player_t *pBot )
{
   edict_t *pEdict;
   pEdict = pBot->pEdict;

   static edict_t *pNewEnemy;
   pNewEnemy = NULL;
   static Vector vecEnd;
   static float distance;
   distance = 0;
   static float nearestdistance;
   nearestdistance = 4000;
   static edict_t *pPlayer;
   pPlayer = NULL;
   static Vector vecFindEnd;
   vecFindEnd = g_vecZero;
   static Vector vecSrc;
   vecSrc = pEdict->v.origin;
   static TraceResult tr_end;
   static edict_t *pent;
   static bool enemy_spotted;
   enemy_spotted = FALSE;
   static float nearestnotv;
   nearestnotv = 99999;

   //Reset visible players
   pBot->visible_alies_number = 0;
   pBot->visible_enemy_number = 0;

   for (int i = 1; i <= gpGlobals->maxClients; i++)
   {
      pPlayer = INDEXENT(i);
      // skip invalid playersand skip self (i.e. this bot)
      if (!IsValidPlayer(pPlayer))
         continue;
      enemy_spotted = FALSE;
      vecEnd = GetGunPosition(pPlayer);
      // if not alive (i.e. dead or dying) skip him
      if (!IsAlive(pPlayer))
      {
         //Say enemy down if see that your anemy is dead!!!
         if ((pBot->pBotEnemy == pPlayer) && (pPlayer->v.deadflag == DEAD_DYING))
         {
            if (FInViewCone( &vecEnd, pEdict , 0.30 ) && (Chance(5)) && FVisible( vecEnd, pEdict ))
               pBot->say_radio |= RADIO_ENEMYDOWN;

            if (plb_canchat->value && Chance(plb_canchat->value))
               FakeClientCommand(pBot->pEdict, "say",chat_text[RANDOM_LONG(0,chat_num-1)].text,NULL);
         }
         continue;
      }
      //Get distance between you and enemy
      distance = (vecEnd - vecSrc).Length();
      //Check your teammates!!!
      //If he is fighting and you don't have any enemies, go help him!!!
      if (FromYourTeam(pBot, &bots[i]))
      {
         if ((!pBot->pBotEnemy) && (FVisible( vecEnd, pEdict)))
         {
            if ((distance < 2500) && (IsShooting(pPlayer)))
            {
               //Your teammate is bot so get just his enemy
               if (bots[i].flags &  FL_FAKECLIENT)
               {
                  if (IsAlive(pBot->pBotEnemy))
                     pBot->pBotEnemy = bots[i].pBotEnemy;
               }
               else
               {
                  //Your teammaete is a player so you will have to find his enemy
                  Vector v_forward, v_right;
                  ANGLEVECTORS( vecEnd, v_forward, v_right, NULL );
                  vecFindEnd = vecEnd + v_forward*2000;
                  UTIL_TraceLine(vecEnd , vecFindEnd, ignore_monsters, dont_ignore_glass, pEdict->v.pContainingEntity, &tr_end);
                  while (pent = UTIL_FindEntityInSphere( pent, tr_end.vecEndPos, 512 ))
                  {
                     if (pent->v.effects & EF_NODRAW)
                        continue;
                     if (!FClassnameIs( pent, "player"))
                        continue;
                     if (!IsAlive(pent) || FromYourTeam(pBot, &bots[ENTINDEX(pent)]))
                        continue;
                     //Enemy is visible go get him!!!
                     if (FVisible( GetGunPosition(pent), pPlayer))
                        pNewEnemy = pent;
                  }
               }
            }
         }

         pBot->visible_alies_number++;
         continue;
      }

      //If there is a smoke grenade dont look through it (in futher only if grenade spawn)
      //  if ((pSG_Grenade) && CPUusage(5) && CheckForSmokeGrenade(pBot, distance))
      //   pBot->blinded_time = gpGlobals->time + 1;

      //Decide here to hide, coruch, snipe or jump
      if (CPUusage(3))
         BotFindAction(pBot, distance, pPlayer);

      //If enemy is near enought to hear him
      if ((pPlayer->v.velocity.Length2D() > 220.0) &&
            (distance < 500) && FVisible( vecEnd, pEdict))
         enemy_spotted = TRUE;

      //or some one is shooting to him
      if (FVisible( vecEnd, pEdict) && (distance < 2000) && IsShooting(pPlayer))
         enemy_spotted = TRUE;

      //Or he just can see enemy
      if (FInViewCone( &vecEnd, pEdict , 0.55 ) && FVisible( vecEnd, pEdict))
      {
         //And dont have current enemy say enemy spotted
         if ((!pBot->pBotEnemy) && Chance(5))
            pBot->say_radio |= RADIO_ENEMYSPOTTED;
         enemy_spotted = TRUE;
      }

      if (enemy_spotted)
      {
         //Search for the nearest enemy
         if (nearestdistance > distance)
         {
            pBot->rush_time = -2; //Make bot not switching to knife (end rush time)
            nearestdistance = distance;
            pNewEnemy = pPlayer;
         }
         pBot->visible_enemy_number++;
      }

      //Search for the nearest not visible enemy
      if (nearestnotv > distance)
      {
         nearestnotv = distance;
         pBot->trEnemy = pPlayer->v.origin;

         if (pBot->rush_time == -1) //If rush time finishes and its time to find nearest goal
            //If we don't have planedGoal or our goal is dead get new one (nearest player)
            if ((!pBot->planedGoal || (FClassnameIs(pBot->planedGoal, "player") && !IsAlive(pBot->planedGoal)) ||
                  (FClassnameIs(pBot->planedGoal, "hostage_entity") && (pBot->planedGoal->v.effects & EF_NODRAW))))
            {
               if (((!bombdroped) && (pBot->player_team & CLIENT_TERRORIST)) || (pBot->player_team & CLIENT_CT))
               {
                  if (pBot->lastNodes[0]) //Does we have alrady cleared?
                     NullLastGoals(pBot); //Clear all used nodes

                  //FakeClientCommand(pBot->pEdict, "say", "ide na przeciwnika" , NULL);
                  pBot->planedGoal = pPlayer;
               }
            }
      }
   }

   if (!pNewEnemy)
   {
      //If have enemy but not found new one, use your current one
      if (pBot->pBotEnemy)
         pNewEnemy = pBot->pBotEnemy;
   }

   return pNewEnemy;
}

Vector BotBodyTarget( edict_t *pBotEnemy, player_t *pBot )
{
   Vector target;
   float fSc;
   int dX, dY, dZ, randomAim;

   //Get distance from enemy to player
   float distance = (pBotEnemy->v.origin - pBot->pEdict->v.origin).Length();

   //Make scale dependent on distance from enemy
   if (distance > 1000)
      fSc = 0.8;
   else if (distance > 100)
      fSc = distance / 1300.0;
   else
      fSc = 0.1;

   //Make bot less accurate when just notice the enemy
   if (pBot->bot_notice_enemy_time > gpGlobals->time)
      fSc = fSc*2;

   fSc = 2*fSc/(float)pBot->bot_skill; //Deadly aiming

   //If have rifle aim better than from other guns
   if (HaveSniperRifle(pBot))
      randomAim = RANDOM_LONG(0,2);
   else if (HaveRifle(pBot))
      randomAim = RANDOM_LONG(1,3);
   else
      randomAim = RANDOM_LONG(2,4);

   //Aim ramdomly
   switch (randomAim)
   {
   case 0:  // VERY GOOD, same as from CBasePlayer::BodyTarget (in player.h)
      target = VECBMODELORIGIN(pBotEnemy);
      dX = RANDOM_FLOAT(-25, 25);
      dY = RANDOM_FLOAT(-25, 25);
      dZ = RANDOM_FLOAT(-25, 25);
      break;
   case 1:  // GOOD, offset a little for x, y, and z
      target = VECBMODELORIGIN(pBotEnemy);
      dX = RANDOM_FLOAT(-25, 25) * fSc;
      dY = RANDOM_FLOAT(-25, 25) * fSc;
      dZ = RANDOM_FLOAT(-30, 30) * fSc;
      break;
   case 2:  // FAIR, offset somewhat for x, y, and z
      target = VECBMODELORIGIN(pBotEnemy);
      dX = RANDOM_FLOAT(-30, 30) * fSc;
      dY = RANDOM_FLOAT(-30, 30) * fSc;
      dZ = RANDOM_FLOAT(-35, 35) * fSc;
      break;
   case 3:  // POOR, offset for x, y, and z
      target = VECBMODELORIGIN(pBotEnemy);
      dX = RANDOM_FLOAT(-35, 35) * fSc;
      dY = RANDOM_FLOAT(-35, 35) * fSc;
      dZ = RANDOM_FLOAT(-45, 45) * fSc;
      break;
   case 4:  // BAD, offset lots for x, y, and z
      target = VECBMODELORIGIN(pBotEnemy);
      dX = RANDOM_FLOAT(-45, 45) * fSc;
      dY = RANDOM_FLOAT(-45, 45) * fSc;
      dZ = RANDOM_FLOAT(-50, 50) * fSc;
      break;
   }

   //Target at enemy + disore
   return target = target + Vector(dX, dY, dZ);
}

void BotShootAtEnemy( player_t *pBot )
{
   Vector vecAim, vecEnd, vecSrc;
   TraceResult tr_end_aim;
   float distance;

   //Get last gun position of bot
   Vector v_forward, v_right;
   ANGLEVECTORS( pBot->last_enemy_point, v_forward, v_right, NULL );
   vecSrc = GetGunPosition(pBot->pEdict);
   vecAim = vecSrc + v_forward*5000;

   UTIL_TraceLine( vecSrc, vecAim, dont_ignore_monsters, ignore_glass,
                   pBot->pEdict->v.pContainingEntity, &tr_end_aim);

   //If we have point at enemy shoot at him
   if (FClassnameIs( tr_end_aim.pHit, "player"))
   {
      //We aim at our teammate so dont shoot
      if (FromYourTeam(pBot, &bots[ENTINDEX(tr_end_aim.pHit)]))
         return;

      // how far away is the enemy?
      distance = (tr_end_aim.vecEndPos - vecSrc).Length();

      pBot->pEdict->v.v_angle = BotPointAt(pBot, vecAim, FALSE);
      //Shoot at enemy (well this fix small problem when
      //aiming and actual body direction aren't thesame
      if (InFieldOfView( pBot, vecAim , pBot->pEdict->v.angles.y) < 5)
         BotFireWeapon(distance, pBot, 0);
   }
   else
   {
      //Aim to him
      vecAim = BotBodyTarget(pBot->pBotEnemy, pBot) - vecSrc;

      // how far away is the enemy?
      distance = vecAim.Length();

      pBot->pEdict->v.v_angle = BotPointAt(pBot, vecAim, FALSE);
      //Shoot at enemy (well this fix small problem when
      //aiming and actual body direction aren't thesame
      if (InFieldOfView( pBot, vecAim , pBot->pEdict->v.angles.y) < 5)
         BotFireWeapon(distance, pBot, 0);
   }

   //Save current vector of aiming for later purpose (v_angle will be change to that time)
   pBot->last_enemy_point = pBot->pEdict->v.v_angle;
}

//This function check if we are able to shoot through walls!!!
bool IsAbleToHit(player_t *pBot)
{
   edict_t *pEdict = pBot->pEdict;

   //If enemy is visible
   if (EnemyIsVisible(pBot, Vector(0,0,RANDOM_LONG(-8,8))) || (pBot->bot_see_dead_time > gpGlobals->time))
   {
      if (pBot->bot_see_enemy_time < gpGlobals->time)
      {
         //Choose fighting style (snipe down, sniper crouching)
         if (BotNoAction(pBot))
         {
            switch (Generate(6))
            {
            case 0:
               pBot->bot_action = BOT_DUCKING; //Duck at one position
               pBot->bot_action |= BOT_STOPED;
               pBot->action_time = gpGlobals->time + 3; //Well start this action for 5 second
               break;
            case 1:
               pBot->bot_action = BOT_DUCKING; //Duck with movement
               pBot->action_time = gpGlobals->time + 7; //Well start this action for 5 second
               break;
            case 2:
               pBot->bot_action |= BOT_STOPED; //Just stnad in place
               pBot->action_time = gpGlobals->time + 2; //Well start this action for 5 second
               break;
            case 3:
            case 4:
               pBot->bot_action = BOT_JUMPING; //Jump often like agressive player
               pBot->action_time = gpGlobals->time + 5; //Well start this action for 5 second
               break;
            }
         }

         //If number of visible enemies is bigger than aliases
         //Rather try to fall back else you can offence
         if (pBot->visible_alies_number < pBot->visible_enemy_number)
            pBot->avoid_angle.y += RANDOM_FLOAT(-9, 9)*10;
         else
            pBot->avoid_angle.y += RANDOM_FLOAT(-4, 4)*10;

         //Here is a time on which bot will shoot less accurate
         pBot->bot_notice_enemy_time = gpGlobals->time + 1;

         //Shoot with some delay
         pBot->shoot_time = gpGlobals->time + (0.4/(float)(pBot->bot_skill));
      }

      pBot->check_grenade = gpGlobals->time + 1;

      //if (IsAlive(pBot->pBotEnemy)) //Well if our enemy still alive we can say that we see him
      //(for human shooting when enemy just die but we are still firing!!!)
      pBot->bot_see_enemy_time = gpGlobals->time + 1;

      //Well now you can shoot
      return TRUE;
   }
   //Enemy is invisible so try to shoot through the wall if have rifle
   else if (((HaveRifle(pBot)) && (pBot->bot_see_enemy_time + 1 > gpGlobals->time))
            || (pBot->bot_see_enemy_time > gpGlobals->time))
   {
      //Gets your and enemy position (a bit above you in case some of you is crouching)
      TraceResult tr_end_self, tr_end_enemy;
      Vector self_pos = GetGunPosition(pEdict) + Vector(0,0,16);
      Vector enemy_pos = GetGunPosition(pBot->pBotEnemy) + Vector(0,0,16);

      //Trace for enemy
      UTIL_TraceLine( self_pos, enemy_pos, ignore_monsters,
                      ignore_glass, pEdict->v.pContainingEntity, &tr_end_self);
      //Enemy trace for you
      UTIL_TraceLine( enemy_pos, self_pos, ignore_monsters,
                      ignore_glass, pEdict->v.pContainingEntity, &tr_end_enemy);

      //Check the thin of wall
      float how_thin = (tr_end_self.vecEndPos - tr_end_enemy.vecEndPos).Length2D();

      //Check how far is enemy from wall
      float how_far = (enemy_pos - tr_end_enemy.vecEndPos).Length2D();

      //Check how far are you...
      float how_far_y = (self_pos - tr_end_self.vecEndPos).Length2D();

      //If wall is 100 unit and you or enemy are 100 unit far from wall then shoot!!!
      if ((how_thin <= 100) && ((how_far <=100) || (how_far_y <= 100)))
         return TRUE;
   }

   //Well there is now way to shoot (player is not visible or not reachable for bullets)
   return FALSE;
}
