//
// PLBot - OLO's bot
//
// (http://www.olo.counter-strike.pl/)
//
// bot_util.cpp
//

/*
 * Copyright (c) 2004 OLO
 * This file is a part of PLBot application.
 * You are not allowed to remove these copyrights.
 */

#include <extdll.h>
#include <sdk_util.h>
#include <cbase.h>
#include <player.h>

#include <dllapi.h>
#include <meta_api.h>
#include <sdk_util.h>

#include "bot.h"
#include "plbot_api.h"  // me

extern char g_argv[1024];

int isFakeClientCommand = 0;
int fake_arg_count;

bool OnThisSameLevel(Vector v_src, Vector v_dest, int high)
{
   return (abs(v_dest.z - v_src.z) < high);
}

bool OnThisSameArea(Vector v_src, Vector v_dest, int area)
{
   //Yes it is
   return ((v_dest - v_src).Length2D() < area);
}

//bool HaveConveyor()
// entvars_t *pevGround = VARS(pev->groundentity);
// if ( pevGround && (pevGround->flags & FL_CONVEYOR) )

edict_t *Finditem( player_t *pBot ,Vector vecSrc, char item_flag[40], int who, int how_near, bool classname)
{
   //Here we can search for custom things
   edict_t *pent = NULL;
   char item_name[40];

   //Check if object is for specifed team
   if ((who != CLIENT_ALLTEAMS) && (pBot->player_team != who))
      return pent;

   //Search for object
   while (pent = UTIL_FindEntityInSphere( pent, vecSrc, how_near ))
   {
      if (pent->v.effects & EF_NODRAW)
         continue;

      if (classname)
         strcpy(item_name, STRING(pent->v.classname));
      else
         strcpy(item_name, STRING(pent->v.model));

      //We have found our thing now you can return this object
      if (FStrnEq(item_name, item_flag, strlen(item_flag)) == FALSE)
         continue;

      return pent;
   }

   //Nothing found
   return pent;
}

bool IsOnLadder( player_t *pBot )
{
   //Check if bot is on ladder
   return (pBot->pEdict->v.movetype == MOVETYPE_FLY);
}

bool EnemyIsVisible( player_t *pBot, Vector vecDis)
{
   //Do we have enemy?
   return ((pBot->pBotEnemy) && (FVisible((GetGunPosition(pBot->pBotEnemy) + vecDis), pBot->pEdict)));
}

void FakeClientCommand(edict_t *pBot, const char *arg1, const char *arg2, const char *arg3)
{
   isFakeClientCommand = 0;

   if (arg1&&*arg1)
   {
      isFakeClientCommand = 1;
      fake_arg_count=1;

      if (arg2&&*arg2)
      {
         if (!arg3)
         {
            sprintf(&g_argv[0], "\"%s\"", arg2);
            fake_arg_count = 2;
         }
         else
         {
            sprintf(&g_argv[0], "\"%s %s\"", arg2, arg3);
            fake_arg_count = 3;
         }
      }

      strcpy(&g_argv[64], arg1);

      if (arg2)
         strcpy(&g_argv[128], arg2);

      if (arg3)
         strcpy(&g_argv[192], arg3);

      MDLL_ClientCommand(pBot);// allow the MOD DLL to execute the ClientCommand...
      isFakeClientCommand = 0;
   }
}

#ifdef MY_DEBUGE_MODE
void DrawBeam(edict_t *pEntity, Vector start, Vector end, int red, int green, int blue)
{
   MESSAGE_BEGIN(MSG_ONE, SVC_TEMPENTITY, NULL, pEntity);
   WRITE_BYTE( TE_BEAMPOINTS);
   WRITE_COORD(start.x);
   WRITE_COORD(start.y);
   WRITE_COORD(start.z);
   WRITE_COORD(end.x);
   WRITE_COORD(end.y);
   WRITE_COORD(end.z);
   WRITE_SHORT( m_spriteTexture );
   WRITE_BYTE( 1 ); // framestart
   WRITE_BYTE( 1 ); // framerate
   WRITE_BYTE( 1 ); // life in 0.1's
   WRITE_BYTE( 5 ); // width
   WRITE_BYTE( 0 );  // noise
   WRITE_BYTE( red );   // r, g, b
   WRITE_BYTE( green );   // r, g, b
   WRITE_BYTE( blue );   // r, g, b
   WRITE_BYTE( 100 );   // brightness
   WRITE_BYTE( 0 );    // speed
   MESSAGE_END();
}
#endif
